VCMD0028040100000000COMPONENT          
Node "rSimResource"
{
Name "My_block"
Id 1
NodeClass 
{
Id 1
Feature "rPrimitiveBoxFeature"
{
Name "Block"

Visible 1
Material  "aluminium"
{
  Ambient
  {
    Red 0.128000006079674
    Green 0.128000006079674
    Blue 0.128000006079674
  }
  Diffuse
  {
    Red 0.560000002384186
    Green 0.560000002384186
    Blue 0.560000002384186
  }
  Specular
  {
    Color
    {
      Red 0.643999993801117
      Green 0.643999993801117
      Blue 0.643999993801117
    }
    Shininess 0.400000005960464
  }
}

Length 
{
  Expression "100{mm}"
}

Width 
{
  Expression "100{mm}"
}

Height 
{
  Expression "100{mm}"
}

}
VCID "92e0977f-cd3e-48b3-839c-2704d0dcc418"
}
Functionality "rPythonScript"
{
Id 1
Name "Script"
Script "from vcScript import *
\nfrom vcProgram import *
\nfrom vcExecutor import *
\nfrom vcStatement import *
\n
\napp = getApplication()
\nsim = getSimulation()
\ncomp = getComponent()
\nsignal = comp.findBehaviour(\"StartSignal\")
\nrobotname = comp.getProperty(\"Robot Name\")
\nrobot = app.findComponent(robotname.Value)
\nif robot != None:
\n  controller = robot.findBehavioursByType(VC_ROBOTCONTROLLER)[0]
\n  robotExecutor = robot.findBehavioursByType(VC_ROBOTEXECUTOR)[0]
\n
\nsignal = comp.findBehaviour(\"StartSignal\")
\n
\ndef OnRun():
\n  if robot != None:
\n    robotExecutor.IsEnabled = True
\n    
\n    detector = sim.newCollisionDetector()
\n    detector.NodeListA = [(robot, VC_NODELIST_INCLUDE, VC_NODELIST_TREE)]
\n    detector.NodeListB = [(sim.World, VC_NODELIST_INCLUDE, VC_NODELIST_TREE),(robot, VC_NODELIST_EXCLUDE, VC_NODELIST_TREE)]
\n    
\n    while sim.IsRunning:
\n      delay(0.1)
\n      hit = detector.testNodeCollisions()
\n      if hit:
\n        #This doesnt stop the robot faster
\n        '''
\n        robotpos = robot.WorldPositionMatrix
\n        tool = controller.InitialTool
\n        toolnode = controller.FlangeNode
\n        if not tool:
\n          tool = controller.Tools[0]
\n        
\n        toolnodepos = toolnode.WorldPositionMatrix
\n        #Az universal robot miatt kell a 180as forgatas!
\n        toolnodepos.rotateAbsZ(180)
\n        toolPos = robotpos * toolnodepos
\n        '''
\n        #need to place a temporaly position on the TCP (Maybe)
\n        here = controller.createTarget()
\n        controller.moveImmediate(here)
\n        
\n        robotExecutor.IsEnabled = False
\n        triggerCondition(lambda : getTrigger())
\n        if signal.Value == True:
\n          robotExecutor.IsEnabled = True"
CompatibilityMode 0
}
Functionality "rSimBoolSignal"
{
Id 2
Name "StartSignal"
Connections
{
"Script"
}
AutomaticReset 1
}
Functionality "rSimInterface"
{
Id 3
Name "Conn_StartSignal_SignalTester_BooleanSignal"
Flags 16390
Section 
{
Fields
{
rSimSignalField
{
Name "Signal"
Signal "StartSignal"
}
}
}
Abstract 1
}
VCID 92e0977f-cd3e-48b3-839c-2704d0dcc418
OriginalUri file:///D:/VisualComponents/Test/Cobot_block.vcmx
Revision 13
Location 1 0 0 0 0 1 0 0 0 0 1 0 0 0 0 1 
ActiveSimulationLevel detailed
BOMname  "NewComponent"

BOMdescription  ""

Category  "Processors"

VariableSpace ""
{
  Variable "rTVariable<rBool>"
  {
    Name "Visible"
    Value 1
    Group -1130
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      MANAGED
    }
  }
  Variable "rTVariable<rString>"
  {
    Name "Robot Name"
    Value "UR10"
    Group 10
    Settings
    {
      VISIBLE
      EDITABLE_DISCONNECTED
      EDITABLE_CONNECTED
      EDITABLE_SIMULATING
      ON_EDIT_REBUILD
      TRANSLATE_USING_GETTEXT
    }
  }
}
}
